#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>

#define FIR_MAP_SIZE 0x1000
#define FIR_Y 0x14
#define FIR_Y_AP_VLD 0x10
#define FIR_X 0x1C
#define FIR_AP_START 0x00

void hw_fir(void *fir_ptr, unsigned int input)
{
	*((unsigned *)(fir_ptr + FIR_X)) = input;
	*((unsigned *)(fir_ptr + FIR_AP_START)) = 0x1;
	*((unsigned *)(fir_ptr + FIR_AP_START)) = 0x0;
	while(1){
		if(*((unsigned *)(fir_ptr + FIR_Y_AP_VLD)))
			break;
		else
			continue;
	}

	printf("%x,", *((unsigned *)(fir_ptr + FIR_Y)));
}


int main(int argc, char *argv[])
{
	int i=0;

	/* for FIR*/
	int fir_fd_left;
	char *fir_uiobf_left="/dev/uio1";
	int fir_fd_right;
	char *fir_uiobf_right="/dev/uio2";
	void *fir_ptr_left;
	void *fir_ptr_right;

	printf("FIR UIO test.\n");

	/* left fir core */
	fir_fd_left = open(fir_uiobf_left, O_RDWR);
	if (fir_fd_left < 1) {
		printf("Invalid UIO device file:%s.\n", fir_uiobf_left);
		return -1;
	}

	/* mmap the UIO devices */
	fir_ptr_left = mmap(NULL, FIR_MAP_SIZE, PROT_READ|PROT_WRITE, MAP_SHARED, fir_fd_left, 0);

	/* right fir core */
	fir_fd_right = open(fir_uiobf_right, O_RDWR);
	if (fir_fd_right < 1) {
		printf("Invalid UIO device file:%s.\n", fir_uiobf_right);
		return -1;
	}
	fir_ptr_right = mmap(NULL, FIR_MAP_SIZE, PROT_READ|PROT_WRITE, MAP_SHARED, fir_fd_right, 0);

	printf("FIR filters Enabled\n");
	printf("\n... Left Filter Output...\n");
	/* send number of coefficients samples with impulse input */
	for (i=0; i<60; i++) {
		if (i==0)
			hw_fir(fir_ptr_left, 0x8000);
		else
			hw_fir(fir_ptr_left, 0x0);
	}
	printf("\n... Right Filter Output...\n");
	for (i=0; i<60; i++) {
		if (i==0)
			hw_fir(fir_ptr_right, 0x8000);
		else
			hw_fir(fir_ptr_right, 0x0);
	}

	printf("\n");
	munmap(fir_ptr_left, FIR_MAP_SIZE);
	munmap(fir_ptr_right, FIR_MAP_SIZE);

	printf("Prog ended\n");

	return 0;
}

